var treeUtil = {};
treeUtil.convertTree = function(rows, mapper) {
  var keyProperty = mapper.id;
  var nameProperty = mapper.name;
  var parentKeyProperty = mapper.pid;
  var childrenProperty = mapper.children||"nodes";
  var extras = mapper.extras;

  function exists(rows, parentId) {
    for (var i = 0; i < rows.length; i++) {
      if (!rows[i]) continue;
      if (rows[i][keyProperty] == parentId) return true;
    }

    return false;
  }
  var rootNodes = []; //root nodes
  // get the top level nodes
  for (var i = 0; i < rows.length; i++) {
    var row = rows[i];
    if (!row) continue;
    var node = {};
    node.text = row[nameProperty];
    node.attributes = row;
    node.id = row[keyProperty];


    node.pid = row[parentKeyProperty];
    if(mapper.extras){
      for(extra in mapper.extras){
        var key = extra;
        var value = mapper.extras[key];
        node[key] = row[value];

      }
    }
    if (!exists(rows, node.pid)) {
      rootNodes.push(node);

    }
  }
  var toDo = [];
  for (var i = 0; i < rootNodes.length; i++) {
    toDo.push(rootNodes[i]);
    rootNodes[i].path = rootNodes[i].id + "/";
    rootNodes[i].pathName = rootNodes[i].text + "/";
  }
  while (toDo.length) {
    var parentNode = toDo.shift(); // the parent node
    // get the children nodes
    for (var i = 0; i < rows.length; i++) {
      var row = rows[i];
      if (!row) continue;
      var node = {};
      node.text = row[nameProperty];
      node.id = row[keyProperty];
      node.attributes = row;

      node.pid = row[parentKeyProperty];
      if(mapper.extras){
        for(extra in mapper.extras){
          var key = extra;
          var value = mapper.extras[key];
          node[key] = row[value];

        }
      }
      if (node.pid == parentNode.id) {
        var child = node;
        child.path = parentNode.path + node.id + "/";
        child.pathName = parentNode.pathName + node.text + "/";
        if (parentNode[childrenProperty]) {
          parentNode[childrenProperty].push(child);
        } else {
          parentNode[childrenProperty] = [child];
        }
        toDo.push(child);
      }
    }
  }
  return rootNodes;
}
module.exports = treeUtil;
